extends KinematicBody


export var speed = 14
export var fall_acceleration = 75 #0 #75
var velocity = Vector3.ZERO

export var jump_impulse = 20
export var bounce_impulse = 16

var player_enemy_hits = 10

signal hit

# Called when the node enters the scene tree for the first time.
func _ready():
	player_enemy_hits = 10
	set_score()
	pass # Replace with function body.


# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass

func _physics_process(delta):
	var direction = Vector3.ZERO
	
	if Input.is_action_pressed("move_right") or Input.is_action_pressed("move_right_2"):
		direction.x += 1
	if Input.is_action_pressed("move_left") or Input.is_action_pressed("move_left_2"):
		direction.x -= 1
	if Input.is_action_pressed("move_down") or Input.is_action_pressed("move_down_2"):
		direction.z += 1
	if Input.is_action_pressed("move_up") or Input.is_action_pressed("move_up_2"):
		direction.z -= 1
	if is_on_floor() and Input.is_action_just_pressed("jump"):
		velocity.y += jump_impulse
	if Input.is_action_just_pressed("quit_game"):
		get_tree().quit()
	
	if direction != Vector3.ZERO:
		direction = direction.normalized()
		$Pivot.look_at(translation + direction, Vector3.UP)
		$AnimationPlayer.playback_speed = 4
	else:
		$AnimationPlayer.playback_speed = 1
		
	velocity.x = direction.x * speed
	velocity.z = direction.z * speed
	velocity.y -= fall_acceleration * delta
	velocity = move_and_slide(velocity, Vector3.UP)
	
	for index in range(get_slide_count()):
		var collision = get_slide_collision(index)
		if collision.collider.is_in_group("mob"):
			var mob = collision.collider
			if Vector3.UP.dot(collision.normal) > 0.1:
				mob.squash()
				velocity.y = bounce_impulse
		
	$Pivot.rotation.x = PI / 6 * velocity.y / jump_impulse

func die():
	emit_signal("hit")
	queue_free()

func _on_MobDetector_body_entered(_body):
	player_enemy_hits = player_enemy_hits - 1
	set_score()
	
	if player_enemy_hits < 1:
		die()

func set_score():
	var score_lab = get_node("/root/Main/UserInterface/ScoreLabel")
	score_lab.score = player_enemy_hits #score_lab.score - 1
	score_lab.text = "Score: %s" % player_enemy_hits #score_lab.score
